import java.io.*;

/** Kommandozeilentool fr die LZ77 und Huffman Komprimierung. */
public class Test {
	public static void main( String[] args ){
		if( args.length >= 5 && args[0].equals("encode") ){
			try {
				BufferedInputStream in = new BufferedInputStream( new FileInputStream(args[1]) );
				BufferedOutputStream out = new BufferedOutputStream( new FileOutputStream( args[2] ) );
				LZ77 myLZ77 = new LZ77( Integer.parseInt(args[3]), Integer.parseInt(args[4]) );
				myLZ77.encode( in, out );
				out.close();
				in.close();
			}catch( Exception e ){ e.printStackTrace(); }
		}
		else if( args.length >= 4 && args[0].equals("decode") ){
			try {
				BufferedInputStream in = new BufferedInputStream( new FileInputStream(args[1]) );
				BufferedOutputStream out = new BufferedOutputStream( new FileOutputStream( args[2] ) );
				LZ77 myLZ77 = new LZ77( Integer.parseInt(args[3]), Integer.parseInt(args[3]) );
				myLZ77.decode( in, out );
				out.close();
				in.close();
			}catch( Exception e ){ e.printStackTrace(); }
		}
		else if( args.length >= 3 && args[0].equals("huffman") ){
			try{
				BufferedInputStream in = new BufferedInputStream( new FileInputStream(args[1]) );
				BufferedOutputStream out = new BufferedOutputStream( new FileOutputStream( args[2] ) );
				Huffman.encode( in, out );
				out.close();
				in.close();
			}catch( Exception e){ e.printStackTrace(); }
		}
		else if( args.length >= 3 && args[0].equals("dehuffman") ){
			try{
				BufferedInputStream in = new BufferedInputStream( new FileInputStream(args[1]) );
				BufferedOutputStream out = new BufferedOutputStream( new FileOutputStream( args[2] ) );
				Huffman.decode( in, out );
				out.close();
				in.close();
			}catch( Exception e){ e.printStackTrace(); }
		}
		else{
			System.out.println("Usage: encode    <input filename> <output filename> <datawindow size> <lookaheadwindow size>");
			System.out.println("       decode    <input filename> <output filename> <datawindow size>");
			System.out.println("       huffman   <input filename> <output filename>");
			System.out.println("       dehuffman <input filename> <output filename>");
		}
	}
}