package simplelz77compressor;

/**
* Verwaltet die derzeit nicht von den Gleitfenstern verwendeten ByteElement
* Instanzen und gibt sie bei Bedarf heraus.
*/
public class ByteElementPool{
	private ByteElement first;		// Zeiger auf das Erste Element im Pool
	
	public ByteElementPool(){
		this.first	= null;
	}
	
	/**
	* Fgt eine Liste von ByteElement Instanzen in den Pool ein.
	* @param a Die Erste Instanz der Liste. Ist es null geschieht garnichts.
	*/
	public void add( ByteElement e ){	
		if( e == null ) return;
		
		if( this.first == null ){
			this.first = e;
		}
		else{
			ByteElement pos = e;
			while( pos.next != null ) pos = pos.next;
			pos.next = this.first;
			this.first = pos;
		}
	}
	
	/**
	* Gibt eine einzelne ByteElement Instanz aus dem Pool zurck.
	* Ist der Pool leer wird eine neue Instanz erzeugt.
	* @returns Eine ByteElement Instanz.
	*/
	public ByteElement get(){
		if( this.first == null ) return new ByteElement();
		
		ByteElement e = this.first;
		this.first = this.first.next;
		e.next = null;
		return e;
	}
}